'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _FormControlMixin = require('./mixins/FormControlMixin');

var _FormControlMixin2 = _interopRequireDefault(_FormControlMixin);

var _HelpBlock = require('./HelpBlock');

var _HelpBlock2 = _interopRequireDefault(_HelpBlock);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var FormGroup = _react2.default.createClass({
    displayName: 'FormGroup',

    mixins: [_FormControlMixin2.default],
    propTypes: {
        controlId: _react2.default.PropTypes.string,
        validationState: _react2.default.PropTypes.oneOf(['success', 'warning', 'error'])
    },
    childContextTypes: {
        formGroup: _react2.default.PropTypes.object.isRequired
    },
    handleError: function handleError(hasError, errorMessage) {
        var helpBlock = this.refs.helpBlock;
        helpBlock && helpBlock.handleError(hasError, errorMessage);
    },
    handleChange: function handleChange(value) {
        var onChange = this.props.onChange;

        onChange && onChange(value);
        this.setState({
            force: true
        });
    },
    getChildContext: function getChildContext() {
        var _props = this.props;
        var isValid = _props.isValid;
        var errorMessage = _props.errorMessage;
        var controlId = _props.controlId;
        var validationState = _props.validationState;
        var value = _props.value;
        var force = _props.force;

        return {
            formGroup: {
                controlId: controlId,
                validationState: validationState,
                value: value,
                isValid: isValid,
                errorMessage: errorMessage,
                force: force || this.state.force,
                onChangeValue: this.handleChange
            }
        };
    },
    render: function render() {
        var _props2 = this.props;
        var validationState = _props2.validationState;
        var className = _props2.className;
        var children = _props2.children;
        var isValid = _props2.isValid;
        var force = _props2.force;

        var hasState = validationState || (isValid ? 'success' : 'error');
        var classes = (0, _classnames2.default)(_defineProperty({
            'form-group': true
        }, 'has-' + hasState, hasState && (force || this.state.force)), className);

        return _react2.default.createElement(
            'div',
            { className: classes },
            children
        );
    }
});

exports.default = FormGroup;